; blueglass/theme.jl



(let*
  (
    (font (get-font "-*-lucida-medium-r-normal-*-*-100-*-*-p-*-iso8859-1"))
    (font-colors (list "grey" "white"))
    
	(title-width
	   (lambda (w)
	      (let
		 ((w-width (car (window-dimensions w))))
		 (max 0 (+ 20 (min (- w-width 74)
                 (text-width (window-name w))))))))
	
	(half-title-width
	     (lambda (w)
	         (/ (title-width w) 2)))
			
	(title-position
	     (lambda (w)
		 (- (/ (car (window-dimensions w)) 2) 
		 (half-title-width w)) ))                 
 
        (update-title-width
	      (lambda (w)
	         (if (eq (window-get w 'current-frame-style) 'blueglass)
		     (rebuild-frame w))))
	
	
	(title-images (list (set-image-border
	                    (make-image "title-bar-active-b.png") 10 10 0 0)
                            (set-image-border
			    (make-image "title-bar-active.png")10 10 0 0)))

        (inset-images (list (set-image-border
	                    (make-image "title-inset-active-b.png") 10 10 0 0)
	                    (set-image-border
			    (make-image "title-inset-active.png")10 10 0 0)))

     	(iconify-images (list (make-image "iconify-normal-b.png")
			      (make-image "iconify-normal.png")
			      (make-image "iconify-normal-g.png")
                              (make-image "iconify-clicked.png")))

     	(maximize-images (list (make-image "maximize-normal-b.png")
                               (make-image "maximize-normal.png")
			       (make-image "maximize-normal-g.png")
  	 		       (make-image "maximize-clicked.png")))

     	(close-images (list (make-image "close-normal-b.png")
			    (make-image "close-normal.png")
			    (make-image "close-normal-g.png")
                            (make-image "close-clicked.png")))

	(menu-images (list (make-image "menu-normal-b.png")
			   (make-image "menu-normal.png")
			   (make-image "menu-normal-g.png")
			   (make-image "menu-clicked.png")))

     	(inset (make-image "inset.png"))
	(border-top (list (make-image "border_top-b.png")
			  (make-image "border_top.png")))
     	(border-bottom (list (make-image "border_bottom-b.png")
			     (make-image "border_bottom.png")
			     (make-image "border_bottom-g.png")))
     	(border-right (list (make-image "border_right-b.png")
			    (make-image "border_right.png")
			    (make-image "border_right-g.png")))
     	(border-left (list (make-image "border_left-b.png")
			   (make-image "border_left.png")
			   (make-image "border_left-g.png")))

     	(corner-tl (list (make-image "corner_top_left-b.png")
			 (make-image "corner_top_left.png")))
     	(corner-tr (list (make-image "corner_top_right-b.png")
			 (make-image "corner_top_right.png")))
     	(corner-bl (list (make-image "corner_bottom_left-b.png")
			 (make-image "corner_bottom_left.png")))
     	(corner-br (list (make-image "corner_bottom_right-b.png")
			 (make-image "corner_bottom_right.png")))

        (corner-tl-2 (list (make-image "corner_top_left_2-b.png")
			   (make-image "corner_top_left_2.png")
			   (make-image "corner_top_left_2-g.png")))
	(corner-tr-2 (list (make-image "corner_top_right_2-b.png")
			   (make-image "corner_top_right_2.png")
			   (make-image "corner_top_right_2-g.png")))
	(corner-bl-2 (list (make-image "corner_bottom_left_2-b.png")
			   (make-image "corner_bottom_left_2.png")
			   (make-image "corner_bottom_left_2-g.png")))
	(corner-br-2 (list (make-image "corner_bottom_right_2-b.png")
			   (make-image "corner_bottom_right_2.png")
			   (make-image "corner_bottom_right_2-g.png")))
				

     	(frame `(

		((background . ,title-images)
		 (top-edge . -16)
		 (left-edge . -3)
		 (right-edge . -3)
		 (class . title))
		 
		((background . ,inset-images)
		 (top-edge . -14)		  
		 (left-edge . 16)
		 (right-edge . 40)
		 (class . title))
		 
		((background . ,inset)
		 (left-edge . ,(lambda (w) (title-position w)))
		 (right-edge . ,(lambda (w) (title-position w)))
		 (top-edge . -13)
		 (foreground . ,font-colors)
		 (font . ,font)
		 (text . ,window-name)
                 (x-justify . center)
                 (y-justify . center)
                 (class . title))


		((background . ,iconify-images)
      		 (top-edge . -14)
		 (right-edge . 25) 
		 (class . iconify-button))

                ((background . ,menu-images)
		 (top-edge . -14)
		 (left-edge . 1)
		 (class . menu-button))

     		((background . ,maximize-images)
      		 (top-edge . -14)
      		 (right-edge . 14)
      		 (class . maximize-button))

    		((background . ,close-images)
      		 (top-edge . -14)
      		 (right-edge . 1)
      		 (class . close-button))

     		((background . ,border-left)
      		 (top-edge . 0)
      		 (bottom-edge . 12)
      		 (left-edge . -2) 
      		 (class . left-border))

     		((background . ,border-right)
      		 (top-edge . 0)
      		 (bottom-edge . 12)
      		 (right-edge . -2)
      		 (class . right-border))

     		((background . ,border-bottom)
      		 (bottom-edge . -2)
      		 (right-edge . 12)  
      		 (left-edge . 12)   
      		 (class . bottom-border))

     		((background . ,corner-bl-2)
      		 (bottom-edge . -3)
      		 (left-edge . -3)  
      		 (class . bottom-left-corner))

     		((background . ,corner-br-2)
      		 (bottom-edge . -3)
      		 (right-edge . -3) 
      		 (class . bottom-right-corner))
	))

	(shaped-frame `(
      
     		((background . ,title-images)
      		 (top-edge . -16)
      		 (left-edge . -3)
      		 (right-edge . -3)
      		 (class . title))
		 
		 ((background . ,inset-images)
		  (top-edge . -14)
                  (left-edge . 16)
                  (right-edge . 40)
		  (class . title))
		  
		 ((background . ,inset)
		  (foreground . ,font-colors)
		  (font . ,font)
		  (text . ,window-name)
                  (x-justify . center)
                  (y-justify . center)
		  (top-edge . -13)
		  (left-edge . ,(lambda (w) (title-position w)))
                  (right-edge . ,(lambda (w) (title-position w)))
		  (class . title))


     		((background . ,iconify-images)
      		 (top-edge . -14)
      		 (right-edge . 25) 
      		 (class . iconify-button))

                ((background . ,menu-images)
		 (top-edge . -14)
		 (left-edge . 1)
		 (class . menu-button))

     		((background . ,maximize-images)
      		 (top-edge . -14)
      		 (right-edge . 14)
      		 (class . maximize-button))

     		((background . ,close-images)
      		 (top-edge . -14)
      		 (right-edge . 1)
      		 (class . close-button))
  
	))

	(transient-frame `(

     		((background . ,border-left)
      		 (top-edge . 12)
      		 (bottom-edge . 12)
      		 (left-edge . -2) 
      		 (class . left-border))

     		((background . ,border-right)
      		 (top-edge . 12)
      		 (bottom-edge . 12)
      		 (right-edge . -2)
      		 (class . right-border))

	     	((background . ,border-top)
      		 (top-edge . -2)
      		 (right-edge . 12)
      		 (left-edge . 12) 
      		 (class . title))

     		((background . ,border-bottom)
      		 (bottom-edge . -2)
      		 (right-edge . 12)  
      		 (left-edge . 12)   
      		 (class . bottom-border))

     		((background . ,corner-tl-2)
      		 (top-edge . -3)
      		 (left-edge . -3)
      		 (class . top-left-corner))

     		((background . ,corner-tr-2)
      		 (top-edge . -3)
      		 (right-edge . -3)
      		 (class . top-right-corner))

     		((background . ,corner-bl-2)
      		 (bottom-edge . -3)
      		 (left-edge . -3)  
      		 (class . bottom-left-corner))

     		((background . ,corner-br-2)
      		 (bottom-edge . -3)
      		 (right-edge . -3) 
      		 (class . bottom-right-corner))

     		((background . ,close-images)
      		 (top-edge . -3)
      		 (right-edge . -16)
      		 (class . close-button))
		
	))
	
	(shaped-transient-frame `(
      
     		((background . ,title-images)
      		 (top-edge . -16)
      		 (left-edge . 0)
      		 (right-edge . 0)
      		 (class . title))
		 
		((background . ,inset-images)
		 (top-edge . -14)
		 (left-edge . 16)
                 (right-edge . 26)
		 (class . title))
		  
		((background . ,inset)
		 (foreground . ,font-colors)
		 (font . ,font)
		 (text . ,window-name)
                 (x-justify . center)
                 (y-justify . center)
		 (top-edge . -13)
		 (left-edge . ,(lambda (w) (title-position w)))
                 (right-edge . ,(lambda (w) (title-position w)))
		 (class . title))

     		((background . ,iconify-images)
      		 (top-edge . -14)
      		 (right-edge . 13) 
      		 (class . iconify-button))
		 
		((background . ,menu-images)
		 (top-edge . -14)
		 (left-edge . 1)
		 (class . menu-button))

     		((background . ,close-images)
      		 (top-edge . -14)
      		 (right-edge . 1)
      		 (class . close-button))

	))
	
  )
  (add-frame-style 'blueglass
    	(lambda (w type)
	  (case type
	    ((default) frame)
	    ((transient) transient-frame)
	    ((shaped) shaped-frame)
	    ((shaped-transient) shaped-transient-frame))))
   
   
   (call-after-property-changed
     'WM_NAME (lambda ()
                (rebuild-frames-with-style 'blueglass))))

